
deferred class MY_SEQUENCE [G] inherit

	ACTIVE [G]
		redefine
			prune_all
		end

	BILINEAR [G]

	FINITE [G]

feature

	readable: BOOLEAN
		do
			Result := not off
		end


	writable: BOOLEAN
		do
			Result := not off
		end

feature

	force (v: like item)
		do
			extend (v)
		ensure then
	 		new_count: count = old count + 1
			item_inserted: has (v)
		end

	append (s: SEQUENCE [G])
		local
			l: like s
		do
			l := s
			if s = Current then
				l := twin
			end
			from
				l.start
			until
				l.exhausted
			loop
				extend (l.item)
				l.forth
			end
		end

	put (v: like item)
		do
			extend (v)
		end

feature -- Removal

	prune (v: like item)
		do
			start
			search (v)
			if not exhausted then
				remove
			end
		end

	prune_all (v: like item)
		do
			from
				start
			until
				exhausted
			loop
				search (v)
				if not exhausted then
					remove
				end
			end
		end

end -- class SEQUENCE
